##### FASS_Base_Scheduler.R
##### Program workflow scheduler.
#####

source(paste0(getwd(), "/FASS_FASS.R"))
source(paste0(getwd(), "/FASS_Base_GeneralDefinitions.R"))
source(paste0(getwd(), "/FASS_Base_Preprocess.R"))

FASS_Scheduler <- function(InputParametersFile, ProjectLocation)
{

  print(paste0(ProjectLocation, InputParametersFile))
  
  source(paste0(ProjectLocation, InputParametersFile))
  
  ### READ DATA FILES
  
  
  Database <- Read_DB()
  
  print(paste0("Database read -  N = ", nrow(Database)))
  
  Database <- PreprocessDB( DataSet = Database, 
                            Symptom_Vars = Symptom_Vars)
  
  print(paste0("Database procesed -  N = ", nrow(Database)))


### COMPUTE THE SCORES

  print("Computing oFASS, oFASS3, nFASS for provided data")

  ScoreData <- FASS_Compute(Database, Systems, Symptoms, SymptomsBySystem, GradeSysts, ExponentSysts, SymptomLambdas)
  
  ### Purge noisy data from the database (Optional)
  ScoreData <- ScoreData[ScoreData$oFASS != 0, ]
  
  for (i in 1:nrow(ScoreData)){
    ScoreData$nFASS[i]  <- log2(ScoreData$nFASS[i]) + 2
    }
    
    
    ### Export the data to a file
  Write_Datafile(PrevFilename = Foodforms_DBName, 
                 Location = paste0(ProjectLocation, DataFolder), 
                 ExtendedName = "_FASS", 
                 FileType = "csv", 
                 DataSet = ScoreData)
  
  ###   Score descriptive
  ScoreData <- FactorizeScores(ScoreData)
  ScoreDescriptive(ScoreData)
  
  }
