##### FASS_Input.R
##### Functions for score and grade computation
#####
##### Results:
#####   Score computed from FOOD database (and added to it)
#####   Grade (based on medical criterion) computed from FOOD database (and added to it)
#####   Grade (computed from the score) computed from FOOD database (and added to it)

#Name of the file and id (FOR CHANGE)

Foodforms_DBName <- "Dataset_example.xlsx"
PatientId_Var <- "patient_no"

#Variable key of the patient
db_merging_keys <- "patient_no"
db_names <- Foodforms_DBName

############################################################
############   SYMPTOMS AND SYSTEMS VARIABLES   ############
############################################################

Systems <- c("Oral", "GI", "Skin", "RC", "L", "BR", "CV", "N")
GradeSysts <- c(1, 2, 2, 2, 4, 4, 5, 5)
ExponentSysts <- c(-1, 0, 0, 0, 2, 2, 4, 4)

SymptomsBySystem <- list(  "itchy_mouth_throat",
                          c("complaints_nausea_or_abdominal_pain","frequent_complaints_nausea","notably_distressed_abd_pain",
                            "emesis_1","emesis_more_1","diarrhoea_1","diarrhoea_more_1"),
                          c("occasional_scrat","continuous_scrat","hard_scrat_excoriations",
                            "few_erythema","erythema_medium","erythema_generalized",
                            "urticaria_less_3","urticaria_less_10","urticaria_generalized",
                            "mid_lip_edema","significant_lip_face_edema","angioedema_generalized"),
                          c("rare_bursts_occasi_sniff", "medium_bursts_frequent_sniff","long_bursts_rhinorrea",
                            "intermittent_rubbing_eye","continuous_rubbing"), 
                          c("persistent_throat_tightness", "throat_clearing_cough_more_3","frequent_cough_hoarseness",
                            "stridor"),
                          c("expiratory_wheezing","inspiratory_expiratory_wheezing","audible_wheezing"),
                          c("tachycardia","moderate_drop_BP", "cardiovascular_collapse"),
                          c("weak","change_mental", "loss_consciousness"))

Symptoms <- c(  "itchy_mouth_throat",
                "complaints_nausea_or_abdominal_pain","frequent_complaints_nausea","notably_distressed_abd_pain",
                  "emesis_1","emesis_more_1","diarrhoea_1","diarrhoea_more_1",
                "occasional_scrat","continuous_scrat","hard_scrat_excoriations",
                  "few_erythema","erythema_medium","erythema_generalized",
                  "urticaria_less_3","urticaria_less_10","urticaria_generalized",
                  "mid_lip_edema","significant_lip_face_edema","angioedema_generalized",
                "rare_bursts_occasi_sniff", "medium_bursts_frequent_sniff","long_bursts_rhinorrea",
                  "intermittent_rubbing_eye","continuous_rubbing", 
                "persistent_throat_tightness", "throat_clearing_cough_more_3","frequent_cough_hoarseness",
                  "stridor",
                "expiratory_wheezing","inspiratory_expiratory_wheezing","audible_wheezing",
                "tachycardia","moderate_drop_BP", "cardiovascular_collapse",
                "weak","change_mental", "loss_consciousness")

SymptomLambdas <- c( 0.05,                                 # Oral
                     0.03, 0.04, 0.05, 0.05, 0.08, 0.05, 0.08,   # GI
                     0.01, 0.02, 0.05, 0.01, 0.05, 0.08, 0.05, 0.07, 0.08, 0.05, 0.07, 0.08, # Skin
                     0.01, 0.05, 0.08, 0.05, 0.08,         # RC
                     0.05, 0.05, 0.07, 0.08,               # L
                     0.06, 0.07, 0.08,                     # BR
                     0.05, 0.07, 0.08,                     # CV
                     0.05, 0.07, 0.08                     # N
)

Symptom_Vars <- Symptoms

#Original codification of Symptom
#For example can be
#Symptom_Values <- c('No', 'Yes', NA) 

Symptom_Values <- c(0, 1, NA)
SymptomNumeric_Values <- c(0, 1, NA)
